Open CASCADE Technology: OpenGl_Quadric Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions
OpenGl_Quadric Class Referenceabstract

Class for rendering of arbitrary primitive array. Tool class for generating tessellation of quadric surface. More...

`#include <OpenGl_Quadric.hxx>`

Inheritance diagram for OpenGl_Quadric:
[legend]

## Public Member Functions
| OpenGl_Quadric ()
| Creates undefined abstract quadric surface. More...
Standard_Boolean | IsDefined () const
| Returns true if quadric has been defined. More...
Standard_Integer | NbSlices () const
| Returns number of slices. More...
Standard_Integer | NbStacks () const
| Returns number of stacks. More...
Standard_Integer | NbVertices () const
| Returns total number of vertices. More...
Standard_Integer | NbTriangles () const
| Returns total number of triangles. More...
virtual void | Release (OpenGl_Context *theContext) Standard_OVERRIDE
| Release GL resources. More...
Public Member Functions inherited from OpenGl_PrimitiveArray
| OpenGl_PrimitiveArray (const OpenGl_GraphicDriver *theDriver)
| Empty constructor. More...
| OpenGl_PrimitiveArray (const OpenGl_GraphicDriver *theDriver, const Graphic3d_TypeOfPrimitiveArray theType, const Handle< Graphic3d_IndexBuffer > &theIndices, const Handle< Graphic3d_Buffer > &theAttribs, const Handle< Graphic3d_BoundBuffer > &theBounds)
| Default constructor. More...
virtual | ~OpenGl_PrimitiveArray ()
| Destructor. More...
virtual void | Render (const Handle< OpenGl_Workspace > &theWorkspace) const
| Render primitives to the window. More...
Standard_Boolean | IsInitialized () const
| Return true if VBOs initialization has been performed. VBO initialization is performed during first Render() call. Notice that this flag does not indicate VBOs validity. More...
void | Invalidate () const
| Invalidate VBO content without destruction. More...
GLint | DrawMode () const
const Handle< Graphic3d_IndexBuffer > & | Indices () const
const Handle< Graphic3d_Buffer > & | Attributes () const
const Handle< Graphic3d_BoundBuffer > & | Bounds () const
const Standard_Size | GetUID () const
| Returns unique ID of primitive array. More...
void | InitBuffers (const Handle< OpenGl_Context > &theContext, const Graphic3d_TypeOfPrimitiveArray theType, const Handle< Graphic3d_IndexBuffer > &theIndices, const Handle< Graphic3d_Buffer > &theAttribs, const Handle< Graphic3d_BoundBuffer > &theBounds)
| Initialize indices, attributes and bounds with new data. More...
Public Member Functions inherited from OpenGl_Element
| OpenGl_Element ()
Standard_Boolean | RenderFiltered (const Handle< OpenGl_Workspace > &theWorkspace, const Handle< OpenGl_RenderFilter > &theFilter) const
| Render element if it passes the filtering procedure. This method should be used for elements which can be used in scope of rendering algorithms. E.g. elements of groups during recursive rendering. If render filter is null, pure rendering is performed. More...

## Protected Member Functions
virtual OpenGl_Vec3 | evalVertex (const Standard_ShortReal theU, const Standard_ShortReal theV) const =0
| Returns surface point for the given parameters. More...
virtual OpenGl_Vec3 | evalNormal (const Standard_ShortReal theU, const Standard_ShortReal theV) const =0
| Returns surface normal for the given parameters. More...
Standard_Boolean | init (const Standard_Integer theNbSlices, const Standard_Integer theNbStacks)
| Initialize primitive. More...
Protected Member Functions inherited from OpenGl_PrimitiveArray
Standard_Boolean | buildVBO (const Handle< OpenGl_Context > &theCtx, const Standard_Boolean theToKeepData) const
| VBO initialization procedures. More...
void | clearMemoryGL (const Handle< OpenGl_Context > &theGlCtx) const
Protected Member Functions inherited from OpenGl_Element
virtual | ~OpenGl_Element ()

## Additional Inherited Members
Public Types inherited from OpenGl_PrimitiveArray
enum | { DRAW_MODE_NONE = -1 }
Static Public Member Functions inherited from OpenGl_Element
template<typename theResource_t >
static void | Destroy (OpenGl_Context *theContext, theResource_t *&theElement)
| Pointer to the context is used because this method might be called when the context is already being destroyed and usage of a handle would be unsafe. More...
Protected Attributes inherited from OpenGl_PrimitiveArray
Handle< OpenGl_VertexBuffer > | myVboIndices
Handle< OpenGl_VertexBuffer > | myVboAttribs
Handle< Graphic3d_IndexBuffer > | myIndices
Handle< Graphic3d_Buffer > | myAttribs
Handle< Graphic3d_BoundBuffer > | myBounds
GLint | myDrawMode
Standard_Boolean | myIsVboInit
Standard_Size | myUID
| Unique ID of primitive array. More...

## Detailed Description

Class for rendering of arbitrary primitive array. Tool class for generating tessellation of quadric surface.

## Constructor & Destructor Documentation

OpenGl_Quadric::OpenGl_Quadric | ( |  | ) |

Creates undefined abstract quadric surface.

## Member Function Documentation

virtual OpenGl_Vec3 OpenGl_Quadric::evalNormal | ( | const Standard_ShortReal | theU,
|  | const Standard_ShortReal | theV
| ) |  | const
| protectedpure virtual

Returns surface normal for the given parameters.

Implemented in OpenGl_Cylinder, OpenGl_Disk, and OpenGl_Sphere.

virtual OpenGl_Vec3 OpenGl_Quadric::evalVertex | ( | const Standard_ShortReal | theU,
|  | const Standard_ShortReal | theV
| ) |  | const
| protectedpure virtual

Returns surface point for the given parameters.

Implemented in OpenGl_Cylinder, OpenGl_Disk, and OpenGl_Sphere.

Standard_Boolean OpenGl_Quadric::init | ( | const Standard_Integer | theNbSlices,
|  | const Standard_Integer | theNbStacks
| ) |  |
| protected

Initialize primitive.

Standard_Boolean OpenGl_Quadric::IsDefined | ( |  | ) | const
| inline

Returns true if quadric has been defined.

Standard_Integer OpenGl_Quadric::NbSlices | ( |  | ) | const
| inline

Returns number of slices.

Standard_Integer OpenGl_Quadric::NbStacks | ( |  | ) | const
| inline

Returns number of stacks.

Standard_Integer OpenGl_Quadric::NbTriangles | ( |  | ) | const
| inline

Returns total number of triangles.

Standard_Integer OpenGl_Quadric::NbVertices | ( |  | ) | const
| inline

Returns total number of vertices.

virtual void OpenGl_Quadric::Release | ( | OpenGl_Context * | theContext | ) |
| virtual

Release GL resources.

Reimplemented from OpenGl_PrimitiveArray.

The documentation for this class was generated from the following file:

- OpenGl_Quadric.hxx